import numpy as np

import pylab as pl

arr = 'VLA-A.array'
Lc = 8.8
Sizes = np.linspace(0.01,1.,1000)

iff = open(arr)

xy = []
for line in iff.readlines():
  if line[:7]=='ANTENNA':
    xy.append(map(float,line.split()[1:]))

xy = np.array(xy)

basels = []
for i in range(len(xy)-1):
  for j in range(i,len(xy)):
    bass = xy[i]-xy[j]
    basels.append(np.sqrt(bass[0]**2.+bass[1]**2.))

pl.hist(basels)
pl.xlabel('Baseline length (m)')
pl.ylabel('# visibilities')
pl.title('VLA-A Baseline Density Distribution')
pl.savefig('VLA_BASELS.eps')

pl.show()

baslin = pl.histogram(basels)
basmed = (baslin[1][1:] + baslin[1][:-1])/2.


def AmpRatSize(s):
#  return -0.3*(s)**2 + 1.0  # Gaussian
#  return -0.5*s**2. + 1.0  # Uniform disk
  return -0.5*(s/0.7)**2. + 1.0  # Ring

def Integ(s):
  numer = np.sum(baslin[0]*(1.-AmpRatSize(2.*s*basmed/np.max(basmed)))**2.)
  return numer/np.sum(baslin[0])

Integral = np.array([Integ(s) for s in Sizes])
SNR = np.sqrt(Lc/(2.*Integral))

# Normalize to the beam (i.e., SNR=3 for size = FWHM)
#SNR *= 3.0/SNR[-1]

pl.plot(np.log10(Sizes),np.log10(SNR))
pl.xlabel('log[Size (FWHM)]')
pl.ylabel(r'log[SNR (3$\sigma$)]')
pl.title('Minimum resolvable size vs. dynamic range')
pl.savefig('VLA_OVERRES.eps')
pl.show()

beta = Sizes[0]/((8.8/2./SNR[0]**2.)**0.25)
print 'Beta is: ', beta
